<template>
    <AppLayout>
        <div class="container mx-auto px-4 mt-8 min-h-screen">
            <h4 class="font-semibold text-gray-900 pb-4 border-b border-gray-200 bg-gray-100">
                Messages
            </h4>
            <div class="chat bg-white border-b border-gray-200 h-96">
                <Conversation :messages="selectedMessages" :match="selectedMatch" @messageSent="addMessage" />
                <MatchList :matches="matches" @selected="startConversation" />
            </div>
        </div>
    </AppLayout>
</template>

<script>
import AppLayout from "@/Layouts/AppLayout.vue";
import Conversation from "./Conversation.vue";
import MatchList from "./MatchList.vue";

export default {
    components: {
        AppLayout,
        Conversation,
        MatchList,
    },
    data() {
        return {
            selectedMatch: null,
            selectedMessages: [],
        };
    },
    props: {
        matches: {
            type: Object,
            required: true,
        },
        messages: {
            type: Array,
            required: true,
        },
        match: {
            type: Object,
            required: true,
        },
    },
    methods: {
        startConversation(match) {
            this.updateUnreadMessages(match);
            axios.get(`/chat/private/conversation/${match.id}`)
                .then(response => {
                    this.selectedMessages = response.data.messages;
                    this.selectedMatch = response.data.match
                }).catch(error => {
                    console.log(error);
                });

            // this.$inertia.get(`/chat/private/conversation/${match.id}`,{}, {
            //     preserveState: true,
            //     onSuccess: (response) => {
            //         this.messages = response.data;
            //         this.selectedMatch = match;
            //     }
            // });
        },
        addMessage(message) {
            this.selectedMessages.push(message);
        },
        handleIncomingMessage(message) {
            if (this.selectedMatch && this.selectedMatch.id == message.from_id) {
                console.log(message);
                this.selectedMessages.push(message);
            }else{
                console.log(message);
                // notify me that there is a new message
                // this.$toast.open({
                //     message: `${message.from.name} sent you a message`,
                //     type: 'is-info',
                //     position: 'is-bottom-right',
                //     duration: 5000,
                // });

                // alert(`${message.from.name} sent you a message`);
            }
            //notify the user that a new message has been received from another user
            // console.log(message.from);
            this.matches.data[this.matches.data.findIndex(m => m.id == message.from.id)].unread_messages_count += 1;
        },
        updateUnreadMessages(match) {
            axios.put(`/chat/private/unread/${match.id}`)
                .then(response => {
                    console.log(response);
                    this.selectedMessages = response.data.messages;
                    this.selectedMatch = response.data.match
                    // update selected match from matched
                    console.log(this.matches);
                    this.matches.data[this.matches.data.findIndex(m => m.id == match.id)].unread_messages_count = 0;
                }).catch(error => {
                    console.log(error);
                });
        },
    },
    mounted() {
        this.selectedMatch = this.match;
        this.selectedMessages = this.messages;

        Echo.private(`chat-private-conversation-${this.$page.props.user.id}`)
            .listen('NewPrivateMessage', (e) => {
                this.handleIncomingMessage(e.message);
            });
    },

}
</script>

<style lang="scss" scoped>
.chat {
    display: flex;
}
</style>
